<?php
/*
Plugin Name: IKLK (iad-kaban-light-cache)
Plugin URI: http://lenta.iadlab.ru/iklk-wp-plagin/
Description: Плагин кеширования
Version: 1.0
Author: IAD, kaban
Author URI: http://lenta.iadlab.ru/
*/

function iad_cache_invalidate()	//Всё изменилось
{
    iad_cache_clear_all();
}

function iad_cache_invalidate_post($post_id)	//Изменился пост
{
	iad_cache_clear_all();
}

function iad_cache_invalidate_comment($comment_id)	//Изменился коммент
{
	iad_cache_clear_current_page();
}

function iad_cache_invalidate_category($category_id) //Изменилась категория
{
	iad_cache_clear_all();
}

//Функции
function iad_cache_clear_all()
{
    iad_cache_clear_dir($_SERVER['DOCUMENT_ROOT'].'/tmp/');	
}

function iad_cache_clear_current_page()
{
	$tmp_request_uri="http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
	$path_temp_dir = $_SERVER['DOCUMENT_ROOT'].'/tmp/';
	
	if (mb_strpos($tmp_request_uri, "clear_cache=y")) 
	{
		$tmp_request_uri = explode("clear_cache=y", $tmp_request_uri);
		$tmp_request_uri = $tmp_request_uri[0];
		$tmp_request_uri = substr($tmp_request_uri, 0, -1);             
	}

	$tmp_page = $path_temp_dir . sha1($tmp_request_uri);
	echo "Удаляю ".$tmp_page;
	unlink($tmp_page);
}

function iad_cache_clear_dir($path)	//Служебная функция, чистит файлуху
{
	if(file_exists($path) && is_dir($path))
	{
		$dirHandle = opendir($path);
		while (false !== ($file = readdir($dirHandle))) 
		{
			if ($file!='.' && $file!='..')// исключаем папки с назварием '.' и '..' 
			{
				$tmpPath=$path.'/'.$file;
				chmod($tmpPath, 0777);
				
				if (is_dir($tmpPath))
	  			{  // если папка
					RemoveDir($tmpPath);
			   	} 
	  			else 
	  			{ 
	  				if(file_exists($tmpPath))
					{
						// удаляем файл 
	  					unlink($tmpPath);
					}
	  			}
			}
		}
		closedir($dirHandle);
		
		// удаляем текущую папку
		//if(file_exists($path))
		//{
		//	rmdir($path);
		//}
	}
	else
	{
	//	echo "Удаляемой папки не существует или это файл!";
	}
}

add_action('switch_theme', 'iad_cache_invalidate', 0);

add_action('edit_post', 'iad_cache_invalidate_post', 0);
add_action('publish_post', 'iad_cache_invalidate_post', 0);
add_action('delete_post', 'iad_cache_invalidate_post', 0);

add_action('edit_comment', 'iad_cache_invalidate_comment', 0);
add_action('publish_comment', 'iad_cache_invalidate_comment', 0);
add_action('delete_comment', 'iad_cache_invalidate_comment', 0);

add_action('add_category_form_pre', 'iad_cache_invalidate_category', 0);
add_action('edit_category_form_pre', 'iad_cache_invalidate_category', 0);
add_action('delete_category_form_pre', 'iad_cache_invalidate_category', 0);

if (mb_strpos($_SERVER['REQUEST_URI'], "clear_cache=y")) 
{
	iad_cache_clear_current_page();
}
if (mb_strpos($_SERVER['REQUEST_URI'], "clear_cache_all=y")) 
{
	iad_cache_clear_all();
}

?>